commit dfd72f526ced041a7df702597d3da0289b8134ca
Author: Gao,Yan <ygao@suse.com>
Date:   Mon Jun 20 18:02:31 2016 +0200

    Test: pengine: Display pending resource state by default when it's available (update regression tests)

diff --git a/pengine/test10/696.summary b/pengine/test10/696.summary
index e19a5a5..af16c93 100644
--- a/pengine/test10/696.summary
+++ b/pengine/test10/696.summary
@@ -2,13 +2,13 @@
 Current cluster status:
 Online: [ hadev1 hadev2 hadev3 ]
 
- DcIPaddr	(ocf::heartbeat:IPaddr):	Started hadev2
- rsc_hadev1	(ocf::heartbeat:IPaddr):	Started hadev3
- rsc_hadev2	(ocf::heartbeat:IPaddr):	Started hadev2
- rsc_hadev3	(ocf::heartbeat:IPaddr):	Started hadev3
+ DcIPaddr	(ocf::heartbeat:IPaddr):	Starting hadev2
+ rsc_hadev1	(ocf::heartbeat:IPaddr):	Started hadev3 (Monitoring)
+ rsc_hadev2	(ocf::heartbeat:IPaddr):	Starting hadev2
+ rsc_hadev3	(ocf::heartbeat:IPaddr):	Started hadev3 (Monitoring)
  Clone Set: DoFencing [child_DoFencing] (unique)
-     child_DoFencing:0	(stonith:ssh):	Started hadev2
-     child_DoFencing:1	(stonith:ssh):	Started hadev3
+     child_DoFencing:0	(stonith:ssh):	Started hadev2 (Monitoring)
+     child_DoFencing:1	(stonith:ssh):	Started hadev3 (Monitoring)
      child_DoFencing:2	(stonith:ssh):	Stopped 
 
 Transition Summary:
diff --git a/pengine/test10/726.summary b/pengine/test10/726.summary
index 962dbf2..920aefe 100644
--- a/pengine/test10/726.summary
+++ b/pengine/test10/726.summary
@@ -2,14 +2,14 @@
 Current cluster status:
 Online: [ ibm1 sgi2 test02 test03 ]
 
- DcIPaddr	(ocf::heartbeat:IPaddr):	Started test03
+ DcIPaddr	(ocf::heartbeat:IPaddr):	Started test03 (Monitoring)
  rsc_sgi2	(ocf::heartbeat:IPaddr):	Stopped 
- rsc_ibm1	(ocf::heartbeat:IPaddr):	Started test03
+ rsc_ibm1	(ocf::heartbeat:IPaddr):	Started test03 (Monitoring)
  rsc_test02	(ocf::heartbeat:IPaddr):	Stopped 
- rsc_test03	(ocf::heartbeat:IPaddr):	Started test03
+ rsc_test03	(ocf::heartbeat:IPaddr):	Started test03 (Monitoring)
  Clone Set: DoFencing [child_DoFencing] (unique)
-     child_DoFencing:0	(stonith:ssh):	Started test02
-     child_DoFencing:1	(stonith:ssh):	Started test03
+     child_DoFencing:0	(stonith:ssh):	Starting test02
+     child_DoFencing:1	(stonith:ssh):	Starting test03
      child_DoFencing:2	(stonith:ssh):	Stopped 
      child_DoFencing:3	(stonith:ssh):	Stopped 
 
diff --git a/pengine/test10/735.summary b/pengine/test10/735.summary
index 71b7b71..69538de 100644
--- a/pengine/test10/735.summary
+++ b/pengine/test10/735.summary
@@ -4,11 +4,11 @@ Online: [ hadev2 hadev3 ]
 OFFLINE: [ hadev1 ]
 
  DcIPaddr	(ocf::heartbeat:IPaddr):	Started hadev2
- rsc_hadev1	(ocf::heartbeat:IPaddr):	Started hadev2
+ rsc_hadev1	(ocf::heartbeat:IPaddr):	Starting hadev2
  rsc_hadev2	(ocf::heartbeat:IPaddr):	Started hadev2
- rsc_hadev3	(ocf::heartbeat:IPaddr):	Stopped 
+ rsc_hadev3	(ocf::heartbeat:IPaddr):	Starting
  Clone Set: DoFencing [child_DoFencing] (unique)
-     child_DoFencing:0	(stonith:ssh):	Stopped 
+     child_DoFencing:0	(stonith:ssh):	Starting
      child_DoFencing:1	(stonith:ssh):	Stopped 
      child_DoFencing:2	(stonith:ssh):	Stopped 
 
diff --git a/pengine/test10/764.summary b/pengine/test10/764.summary
index da85bba..2d43eae 100644
--- a/pengine/test10/764.summary
+++ b/pengine/test10/764.summary
@@ -7,7 +7,7 @@ OFFLINE: [ posic042 posic044 ]
  rsc_posic041	(ocf::heartbeat:IPaddr):	Started posic041
  rsc_posic042	(ocf::heartbeat:IPaddr):	Started posic041
  rsc_posic043	(ocf::heartbeat:IPaddr):	Started posic043
- rsc_posic044	(ocf::heartbeat:IPaddr):	Started posic041
+ rsc_posic044	(ocf::heartbeat:IPaddr):	Starting posic041
  Clone Set: DoFencing [child_DoFencing] (unique)
      child_DoFencing:0	(stonith:ssh):	Started posic043
      child_DoFencing:1	(stonith:ssh):	Started posic041
diff --git a/pengine/test10/797.summary b/pengine/test10/797.summary
index f47fe79..6e78255 100644
--- a/pengine/test10/797.summary
+++ b/pengine/test10/797.summary
@@ -9,7 +9,7 @@ Online: [ c001n01 c001n02 c001n03 ]
  rsc_c001n03	(ocf::heartbeat:IPaddr):	Started c001n03
  rsc_c001n01	(ocf::heartbeat:IPaddr):	Started c001n01
  Clone Set: DoFencing [child_DoFencing] (unique)
-     child_DoFencing:0	(stonith:ssh):	Started [ c001n01 c001n03 ]
+     child_DoFencing:0	(stonith:ssh):	Started (Monitoring)[ c001n01 c001n03 ]
      child_DoFencing:1	(stonith:ssh):	Started c001n02
      child_DoFencing:2	(stonith:ssh):	Started c001n03
      child_DoFencing:3	(stonith:ssh):	Stopped 
diff --git a/pengine/test10/bug-5186-partial-migrate.summary b/pengine/test10/bug-5186-partial-migrate.summary
index 5e62a23..4d0b10e 100644
--- a/pengine/test10/bug-5186-partial-migrate.summary
+++ b/pengine/test10/bug-5186-partial-migrate.summary
@@ -4,7 +4,7 @@ Node bl460g1n7 (3232261593): UNCLEAN (offline)
 Online: [ bl460g1n6 bl460g1n8 ]
 
  prmDummy	(ocf::pacemaker:Dummy):	Started bl460g1n7 (UNCLEAN)
- prmVM2	(ocf::heartbeat:VirtualDomain):	Started bl460g1n7 (UNCLEAN)
+ prmVM2	(ocf::heartbeat:VirtualDomain):	Migrating bl460g1n7 (UNCLEAN)
  Resource Group: grpStonith6
      prmStonith6-1	(stonith:external/stonith-helper):	Started bl460g1n8 
      prmStonith6-2	(stonith:external/ipmi):	Started bl460g1n8 
diff --git a/pengine/test10/mon-rsc-3.summary b/pengine/test10/mon-rsc-3.summary
index 4cb7be4..d8f1846 100644
--- a/pengine/test10/mon-rsc-3.summary
+++ b/pengine/test10/mon-rsc-3.summary
@@ -2,7 +2,7 @@
 Current cluster status:
 Online: [ node1 node2 ]
 
- rsc1	(heartbeat:apache):	Started node1
+ rsc1	(heartbeat:apache):	Starting node1
 
 Transition Summary:
 
diff --git a/pengine/test10/mon-rsc-4.summary b/pengine/test10/mon-rsc-4.summary
index a532bec..92b0f68 100644
--- a/pengine/test10/mon-rsc-4.summary
+++ b/pengine/test10/mon-rsc-4.summary
@@ -3,7 +3,7 @@ Current cluster status:
 Node node2 (uuid2): standby
 Online: [ node1 ]
 
- rsc1	(heartbeat:apache):	Started node2
+ rsc1	(heartbeat:apache):	Starting node2
 
 Transition Summary:
  * Move    rsc1	(Started node2 -> node1)