commit 1122b1866f496124b346b75ff955be240553d28c
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Tue Jul 19 15:10:27 2016 -0500

    Test: pengine: update regression tests for new unfence ordering

diff --git a/pengine/test10/unfence-definition.dot b/pengine/test10/unfence-definition.dot
index 1ae2367..a9e7e6b 100644
--- a/pengine/test10/unfence-definition.dot
+++ b/pengine/test10/unfence-definition.dot
@@ -12,8 +12,6 @@ digraph "g" {
 "clvmd-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd-clone_stopped_0" -> "clvmd-clone_start_0" [ style = bold]
 "clvmd-clone_stopped_0" -> "dlm-clone_stop_0" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "clvmd-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd:1_monitor_0 virt-2" -> "clvmd-clone_start_0" [ style = bold]
 "clvmd:1_monitor_0 virt-2" [ style=bold color="green" fontcolor="black"]
@@ -32,6 +30,7 @@ digraph "g" {
 "clvmd_stop_0 virt-1" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd_stop_0 virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" -> "dlm_stop_0 virt-1" [ style = bold]
+"clvmd_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "dlm-clone_running_0" -> "clvmd-clone_start_0" [ style = bold]
 "dlm-clone_running_0" [ style=bold color="green" fontcolor="orange"]
@@ -43,8 +42,6 @@ digraph "g" {
 "dlm-clone_stop_0" -> "dlm_stop_0 virt-1" [ style = bold]
 "dlm-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stopped_0" -> "dlm-clone_start_0" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "dlm-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "dlm:2_monitor_0 virt-3" -> "dlm-clone_start_0" [ style = bold]
 "dlm:2_monitor_0 virt-3" -> "stonith 'on' virt-3" [ style = bold]
@@ -58,6 +55,7 @@ digraph "g" {
 "dlm_stop_0 virt-1" -> "all_stopped" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm_start_0 virt-1" [ style = bold]
+"dlm_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "dlm_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "fencing_delete_0 virt-1" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_delete_0 virt-1" [ style=bold color="green" fontcolor="black"]
@@ -69,11 +67,11 @@ digraph "g" {
 "fencing_stop_0 virt-1" -> "fencing_delete_0 virt-1" [ style = bold]
 "fencing_stop_0 virt-1" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-1" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-1" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
+"stonith 'on' virt-1" -> "dlm_start_0 virt-1" [ style = bold]
 "stonith 'on' virt-1" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-3" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-3" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
+"stonith 'on' virt-3" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "fencing_monitor_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' virt-4" -> "stonith_complete" [ style = bold]
diff --git a/pengine/test10/unfence-definition.exp b/pengine/test10/unfence-definition.exp
index 9d23a2a..64b9735 100644
--- a/pengine/test10/unfence-definition.exp
+++ b/pengine/test10/unfence-definition.exp
@@ -69,6 +69,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="13" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -104,6 +107,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="18" operation="start" operation_key="dlm-clone_start_0"/>
       </trigger>
       <trigger>
@@ -173,12 +179,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <rsc_op id="10" operation="monitor" operation_key="dlm:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
       <trigger>
@@ -195,6 +195,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="14" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:0_start_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -258,6 +261,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="17" operation="start" operation_key="dlm:2_start_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
       <trigger>
@@ -332,12 +338,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <rsc_op id="8" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
       <trigger>
@@ -387,12 +387,6 @@
       <trigger>
         <rsc_op id="11" operation="monitor" operation_key="clvmd:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
-      <trigger>
-        <pseudo_event id="21" operation="stopped" operation_key="dlm-clone_stopped_0"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="29" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="25">
@@ -403,10 +397,10 @@
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="21" operation="stopped" operation_key="dlm-clone_stopped_0"/>
+        <rsc_op id="13" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
-        <pseudo_event id="29" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
+        <rsc_op id="22" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/unfence-definition.summary b/pengine/test10/unfence-definition.summary
index a317807..05f8003 100644
--- a/pengine/test10/unfence-definition.summary
+++ b/pengine/test10/unfence-definition.summary
@@ -26,23 +26,23 @@ Executing cluster transition:
  * Pseudo action:   clvmd-clone_stop_0
  * Fencing virt-4 (reboot)
  * Pseudo action:   stonith_complete
+ * Fencing virt-3 (on)
+ * Resource action: fencing         monitor on virt-3
+ * Resource action: fencing         stop on virt-1
  * Resource action: clvmd           stop on virt-1
  * Pseudo action:   clvmd-clone_stopped_0
+ * Resource action: fencing         delete on virt-1
  * Pseudo action:   dlm-clone_stop_0
  * Resource action: dlm             stop on virt-1
  * Pseudo action:   dlm-clone_stopped_0
- * Fencing virt-3 (on)
- * Fencing virt-1 (on)
- * Resource action: fencing         monitor on virt-3
- * Resource action: fencing         stop on virt-1
  * Pseudo action:   dlm-clone_start_0
+ * Fencing virt-1 (on)
  * Pseudo action:   all_stopped
- * Resource action: fencing         delete on virt-1
+ * Resource action: fencing         start on virt-1
  * Resource action: dlm             start on virt-1
  * Resource action: dlm             start on virt-3
  * Pseudo action:   dlm-clone_running_0
  * Pseudo action:   clvmd-clone_start_0
- * Resource action: fencing         start on virt-1
  * Resource action: clvmd           start on virt-1
  * Resource action: clvmd           start on virt-2
  * Resource action: clvmd           start on virt-3
diff --git a/pengine/test10/unfence-parameters.dot b/pengine/test10/unfence-parameters.dot
index 6b23965..c96d314 100644
--- a/pengine/test10/unfence-parameters.dot
+++ b/pengine/test10/unfence-parameters.dot
@@ -12,9 +12,6 @@ digraph "g" {
 "clvmd-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd-clone_stopped_0" -> "clvmd-clone_start_0" [ style = bold]
 "clvmd-clone_stopped_0" -> "dlm-clone_stop_0" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-2" [ style = bold]
-"clvmd-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "clvmd-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd:1_monitor_0 virt-2" -> "clvmd-clone_start_0" [ style = bold]
 "clvmd:1_monitor_0 virt-2" -> "stonith 'on' virt-2" [ style = bold]
@@ -37,6 +34,7 @@ digraph "g" {
 "clvmd_stop_0 virt-1" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd_stop_0 virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" -> "dlm_stop_0 virt-1" [ style = bold]
+"clvmd_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "clvmd_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "dlm-clone_running_0" -> "clvmd-clone_start_0" [ style = bold]
 "dlm-clone_running_0" [ style=bold color="green" fontcolor="orange"]
@@ -50,9 +48,6 @@ digraph "g" {
 "dlm-clone_stop_0" -> "dlm_stop_0 virt-2" [ style = bold]
 "dlm-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stopped_0" -> "dlm-clone_start_0" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-1" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-2" [ style = bold]
-"dlm-clone_stopped_0" -> "stonith 'on' virt-3" [ style = bold]
 "dlm-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "dlm:2_monitor_0 virt-3" -> "dlm-clone_start_0" [ style = bold]
 "dlm:2_monitor_0 virt-3" -> "stonith 'on' virt-3" [ style = bold]
@@ -72,11 +67,13 @@ digraph "g" {
 "dlm_stop_0 virt-1" -> "all_stopped" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm_start_0 virt-1" [ style = bold]
+"dlm_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "dlm_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
 "dlm_stop_0 virt-2" -> "all_stopped" [ style = bold]
 "dlm_stop_0 virt-2" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_stop_0 virt-2" -> "dlm_start_0 virt-2" [ style = bold]
 "dlm_stop_0 virt-2" -> "dlm_stop_0 virt-1" [ style = bold]
+"dlm_stop_0 virt-2" -> "stonith 'on' virt-2" [ style = bold]
 "dlm_stop_0 virt-2" [ style=bold color="green" fontcolor="black"]
 "fencing_monitor_0 virt-3" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_monitor_0 virt-3" -> "fencing_stop_0 virt-1" [ style = bold]
@@ -85,14 +82,14 @@ digraph "g" {
 "fencing_stop_0 virt-1" -> "all_stopped" [ style = bold]
 "fencing_stop_0 virt-1" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-1" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-1" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
+"stonith 'on' virt-1" -> "dlm_start_0 virt-1" [ style = bold]
 "stonith 'on' virt-1" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-2" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-2" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-2" -> "clvmd:1_start_0 virt-2" [ style = bold]
+"stonith 'on' virt-2" -> "dlm_start_0 virt-2" [ style = bold]
 "stonith 'on' virt-2" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-3" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-3" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
+"stonith 'on' virt-3" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "fencing_monitor_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' virt-4" -> "stonith_complete" [ style = bold]
diff --git a/pengine/test10/unfence-parameters.exp b/pengine/test10/unfence-parameters.exp
index 48ef3bc..16aa30d 100644
--- a/pengine/test10/unfence-parameters.exp
+++ b/pengine/test10/unfence-parameters.exp
@@ -53,6 +53,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="12" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -91,6 +94,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="13" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:0_start_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -126,6 +132,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="15" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:1_start_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
       <trigger>
@@ -204,15 +213,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <rsc_op id="9" operation="monitor" operation_key="dlm:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
       <trigger>
@@ -229,6 +229,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="13" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:0_start_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -264,6 +267,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="15" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:1_start_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
       <trigger>
@@ -295,6 +301,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="16" operation="start" operation_key="dlm:2_start_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
       <trigger>
@@ -369,15 +378,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <rsc_op id="7" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
       <trigger>
@@ -427,12 +427,6 @@
       <trigger>
         <rsc_op id="10" operation="monitor" operation_key="clvmd:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
-      <trigger>
-        <pseudo_event id="20" operation="stopped" operation_key="dlm-clone_stopped_0"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="28" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="26">
@@ -446,10 +440,7 @@
         <rsc_op id="7" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
       <trigger>
-        <pseudo_event id="20" operation="stopped" operation_key="dlm-clone_stopped_0"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="28" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
+        <rsc_op id="14" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
     </inputs>
   </synapse>
@@ -461,10 +452,10 @@
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="20" operation="stopped" operation_key="dlm-clone_stopped_0"/>
+        <rsc_op id="12" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
-        <pseudo_event id="28" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
+        <rsc_op id="21" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/unfence-parameters.summary b/pengine/test10/unfence-parameters.summary
index bca4f96..41fed90 100644
--- a/pengine/test10/unfence-parameters.summary
+++ b/pengine/test10/unfence-parameters.summary
@@ -27,25 +27,25 @@ Executing cluster transition:
  * Pseudo action:   clvmd-clone_stop_0
  * Fencing virt-4 (reboot)
  * Pseudo action:   stonith_complete
+ * Fencing virt-3 (on)
+ * Resource action: fencing         monitor on virt-3
  * Resource action: clvmd           stop on virt-1
  * Pseudo action:   clvmd-clone_stopped_0
+ * Resource action: fencing         stop on virt-1
  * Pseudo action:   dlm-clone_stop_0
  * Resource action: dlm             stop on virt-2
+ * Fencing virt-2 (on)
  * Resource action: dlm             stop on virt-1
  * Pseudo action:   dlm-clone_stopped_0
- * Fencing virt-3 (on)
- * Fencing virt-2 (on)
- * Fencing virt-1 (on)
- * Resource action: fencing         monitor on virt-3
  * Pseudo action:   dlm-clone_start_0
- * Resource action: fencing         stop on virt-1
+ * Fencing virt-1 (on)
+ * Pseudo action:   all_stopped
+ * Resource action: fencing         start on virt-1
  * Resource action: dlm             start on virt-1
  * Resource action: dlm             start on virt-2
  * Resource action: dlm             start on virt-3
  * Pseudo action:   dlm-clone_running_0
  * Pseudo action:   clvmd-clone_start_0
- * Pseudo action:   all_stopped
- * Resource action: fencing         start on virt-1
  * Resource action: clvmd           start on virt-1
  * Resource action: clvmd           start on virt-2
  * Resource action: clvmd           start on virt-3
diff --git a/pengine/test10/unfence-startup.dot b/pengine/test10/unfence-startup.dot
index 97eba4a..20f1367 100644
--- a/pengine/test10/unfence-startup.dot
+++ b/pengine/test10/unfence-startup.dot
@@ -27,8 +27,8 @@ digraph "g" {
 "dlm:2_start_0 virt-3" -> "dlm-clone_running_0" [ style = bold]
 "dlm:2_start_0 virt-3" [ style=bold color="green" fontcolor="black"]
 "fencing_monitor_0 virt-3" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-3" -> "clvmd-clone_start_0" [ style = bold]
-"stonith 'on' virt-3" -> "dlm-clone_start_0" [ style = bold]
+"stonith 'on' virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
+"stonith 'on' virt-3" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "fencing_monitor_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' virt-4" -> "stonith_complete" [ style = bold]
diff --git a/pengine/test10/unfence-startup.exp b/pengine/test10/unfence-startup.exp
index 7595cf3..569fd12 100644
--- a/pengine/test10/unfence-startup.exp
+++ b/pengine/test10/unfence-startup.exp
@@ -21,6 +21,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="17" operation="start" operation_key="dlm-clone_start_0"/>
       </trigger>
       <trigger>
@@ -60,9 +63,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <rsc_op id="8" operation="monitor" operation_key="dlm:2_monitor_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
     </inputs>
@@ -101,6 +101,9 @@
     </action_set>
     <inputs>
       <trigger>
+        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
+      </trigger>
+      <trigger>
         <rsc_op id="16" operation="start" operation_key="dlm:2_start_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
       <trigger>
@@ -149,9 +152,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
-      </trigger>
-      <trigger>
         <rsc_op id="6" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
       </trigger>
       <trigger>
diff --git a/pengine/test10/unfence-startup.summary b/pengine/test10/unfence-startup.summary
index db0f307..76bc0fc 100644
--- a/pengine/test10/unfence-startup.summary
+++ b/pengine/test10/unfence-startup.summary
@@ -18,6 +18,7 @@ Transition Summary:
 
 Executing cluster transition:
  * Resource action: dlm             monitor on virt-3
+ * Pseudo action:   dlm-clone_start_0
  * Resource action: clvmd           monitor on virt-2
  * Resource action: clvmd           monitor on virt-3
  * Fencing virt-4 (reboot)
@@ -25,7 +26,6 @@ Executing cluster transition:
  * Fencing virt-3 (on)
  * Pseudo action:   all_stopped
  * Resource action: fencing         monitor on virt-3
- * Pseudo action:   dlm-clone_start_0
  * Resource action: dlm             start on virt-3
  * Pseudo action:   dlm-clone_running_0
  * Pseudo action:   clvmd-clone_start_0